/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024  Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const tokeCommandModel = require('../../../schemas/tokebot/tokeCommandSchema');

module.exports.get = async function(req, res){
    try{
        const tokeList = await tokeCommandModel.getCommandStrings();

        res.status(200);
        return res.send(tokeList);
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.post = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            const {command} = matchedData(req);
            const tokeDB = await tokeCommandModel.findOne({command});

            if(tokeDB != null){
                return errorHandler(res, `Toke command '!${command}' already exists!`);
            }

            //Add the toke
            await tokeCommandModel.create({command});

            //Return the updated command list
            res.status(200);
            return res.send(await tokeCommandModel.getCommandStrings());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.delete = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            const {command} = matchedData(req);
            const tokeDB = await tokeCommandModel.findOne({command});

            if(tokeDB == null){
                return errorHandler(res, `Cannot delete non-existant toke command '!${command}'!`);
            }

            await tokeDB.deleteOne();

            //Return the updated command list
            res.status(200);
            return res.send(await tokeCommandModel.getCommandStrings());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}